package com.imcode.forum;

public class SimpleForumUser implements ForumUser {

    private final String name ;
    private final String alias ;
    private final String emailAddress ;
    private final String data ;

    public SimpleForumUser(String name, String alias, String emailAddress, String data) {
        this.name = name;
        this.alias = alias;
        this.emailAddress = emailAddress;
        this.data = data;
    }

    public String getName() {
        return name;
    }

    public String getAlias() {
        return alias;
    }

    public String getEmailAddress() {
        return emailAddress;
    }

    public String getData() {
        return data;
    }

    public boolean equals(Object o) {
        if ( this == o ) {
            return true;
        }
        if ( o == null || getClass() != o.getClass() ) {
            return false;
        }

        final SimpleForumUser that = (SimpleForumUser) o;

        return nullSafeEqual(name, that.name) && nullSafeEqual(alias, that.alias) 
               && nullSafeEqual(emailAddress, that.emailAddress) && nullSafeEqual(data, that.data) ;
    }
    
    private boolean nullSafeEqual(Object o1, Object o2) {
        if ( o1 == null ^ o2 == null ) {
            return false ;
        }
        return o1 == null || o1.equals(o2);
    }

    public int hashCode() {
        int result = name != null ? name.hashCode() : 0;
        result = 29 * result + ( alias != null ? alias.hashCode() : 0 );
        result = 29 * result + ( emailAddress != null ? emailAddress.hashCode() : 0 );
        result = 29 * result + ( data != null ? data.hashCode() : 0 );
        return result;
    }
}
