package com.imcode.forum.sql;

import com.imcode.db.handlers.RowTransformer;
import com.imcode.forum.Forum;

import java.sql.ResultSet;
import java.sql.SQLException;

class SqlThreadFactory implements RowTransformer {

    private SqlRepository sqlRepository;
    private final Forum forum;

    SqlThreadFactory(SqlRepository sqlRepository, Forum forum) {
        this.sqlRepository = sqlRepository;
        this.forum = forum;
    }

    public Object createObjectFromResultSetRow(ResultSet resultSet) throws SQLException {
        String threadId = resultSet.getString("thread_id");
        String forumId = resultSet.getString("forum_id");
        return new SqlThread(threadId, sqlRepository, forumId, forum);
    }

    public Class getClassOfCreatedObjects() {
        return SqlThread.class ;
    }
}
